#include	<windows.h>
#include	"common.h"
#include	"np2.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"bios.h"
#include	"nevent.h"
#include	"pc_core.h"
#include	"sysport.h"
#include	"dosio.h"
#include	"itfrom.h"
#include	"fdd_mtr.h"

static	BYTE	neccheck[] = "Copyright (C) 1983 by NEC Corporation";

						// 00/05/18 MS-DOS6.2 on PC-9801VX calling proc
static	BYTE	printmain[] = {0x5a, 0x1f, 0xb4, 0x00, 0xcf};


#ifdef __cplusplus
extern "C" {
#endif
	BYTE	itf_bank = 0;
#ifdef __cplusplus
}
#endif


void bios_init(void) {

	int		i;

	itf_bank = 0;
	for (i=0; i<0x100; i++) {
		*(WORD *)(&mem[i*4+0]) = 0x003e;
		*(WORD *)(&mem[i*4+2]) = 0xfd00;
	}
	for (i=0; i<0x20; i++) {
		*(WORD *)(&mem[i*4+0]) = i << 1;
		*(WORD *)(&mem[0xfd000+i*2]) = 0xcf90;
	}
	*(WORD *)(&mem[0xfd040]) = 0xcf90;

	lio_init();

	*(WORD *)(&mem[0xfd800]) = 0xcb90;
	*(WORD *)(&mem[0xfd802]) = 0xcb90;
	*(WORD *)(&mem[0xfffe8]) = 0xcb90;
	*(WORD *)(&mem[0xfffec]) = 0xcb90;
	mem[0xffff0] = 0xea;
	*(DWORD *)(&mem[0xffff1]) = 0xfd800000;

#if 1
	CopyMemory(&mem[0x2f8000], itfrom, sizeof(itfrom));
#else
	{
		FILEH	fh;
		fh = file_open_c("itf.bin");
		if (fh != (FILEH)-1) {
			file_read(fh, &mem[0x2f8000], 0x8000);
			file_close(fh);
		}
	}
#endif
	mem[0x2ffff0] = 0xea;
	*(DWORD *)(&mem[0x2ffff1]) = 0xf8000000;

	// NEC CHECK
	memcpy(&mem[0xe8dd8], neccheck, 0x25);

	// INT 1a +19h
	memcpy(&mem[0xfd04d], printmain, sizeof(printmain));
	memcpy(&mem[0xf538e], itfrom + (*(WORD *)&itfrom[2]), 0x27);

	MEM_CRT_STS_FLAG = 0x84;
	MEM_EXPMMSZ = 0x08;
	MEM_BIOS_FLAG0 = 0x03;					// 00/05/17 beep tone
	MEM_BIOS_FLAG &= 0x80;
	MEM_BIOS_FLAG |= 0x24;
	MEM_PRXCRT = 0x06;
	mem[0x00055c] = 0x03;

	CopyMemory(&mem[0x0fde00], keytable[0], 0x300);
	bios0x09_init();
}

static void bios_reset(void) {

	if (systemport.c & 0x80) {
		if (!(systemport.c & 0x20)) {
			CPUTYPE = 0;
			if (np2cfg.dipsw[2] & 0x80) {
				CPUTYPE = CPUTYPE_V30;
			}
		}
		I286_CS = 0x0000;
		I286_IP = 0x04f8;
		I286_DS = 0x0000;
		I286_DX = 0x43d;
		I286_AL = 0x10;
		mem[0x004f8] = 0xee;		// out	dx, ax
		mem[0x004f9] = 0xea;		// call	far
		*(DWORD *)(&mem[0x004fa]) = 0xffff0000;
	}
	else {
		I286_SP = *(WORD *)(&mem[0x00404]);
		I286_SS = *(WORD *)(&mem[0x00406]);
	}
}


WORD __fastcall biosfunc(DWORD adrs) {

	if ((itf_bank) && (adrs >= 0xf8000) && (adrs < 0x100000)) {
		I286_IP--;
		nevent.remainclock = -1;
		return(1);
	}
	if ((adrs >= 0xfd000) && (adrs < 0x0fd042)) {
		if (adrs & 1) {
			return(0);
		}
		nevent.remainclock -= 300;
		switch((adrs - 0xfd000) >> 1) {
			case 0x08:
				bios0x08();
				break;

			case 0x09:
				bios0x09();
				break;

			case 0x0a:
			case 0x0b:
			case 0x0c:
			case 0x0d:
			case 0x0e:
			case 0x0f:
				pic_w(0, 0x20);
				break;

			case 0x10:
			case 0x11:
			case 0x12:
			case 0x13:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
				pic_w(8, 0x20);
				if (!pic[1].isr) {
					pic_w(0, 0x20);
				}
				break;

			case 0x18:
				bios0x18();
				break;

			case 0x1b:
				bios0x1b();
				break;

			case 0x1c:
				bios0x1c();
				break;

			case 0x20:
				if (mtr_curevent) {
					I286_IP--;
					nevent.remainclock = -1;
					I286_IFLAG = I_FLAG;
					pic_irq();
				}
				break;
		}
		return(1);
	}
	if ((adrs >= 0xf9a00) && (adrs < 0x0f9a24)) {
		if (!(adrs & 1)) {
			bios_lio((BYTE)((adrs - 0xf9a00) >> 1));
		}
		return(0);
	}

	// Zbg
	if (adrs == 0xfd800) {
		bios_reset();
		return(1);
	}
	// u[gXgbv
	if (adrs == 0xfd802) {
		bootstrapload();
		I286_CS = 0x1fc0;
		I286_IP = 0x0000;
		return(1);
	}
	// u[gXgbv[h
	if ((adrs == 0xfffe8) || (adrs == 0xfffec)) {
		nevent.remainclock -= 2000;
		bootstrapload();
		return(0);
	}
	I286_IP--;
	nevent.remainclock = -1;
	return(1);
}


I286_OUT itf_ctrl(WORD port, BYTE value) {

	switch(value) {
		case 0x10:
			itf_bank = 1;
			break;
		case 0x12:
			itf_bank = 0;
			break;
	}
}
