#include	<windows.h>
#include	"common.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"pic.h"
#include	"keyboard.h"

BYTE keytable[8][0x60] = {
	{	//												normal
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '1', '2', '3', '4', '5', '6', '7',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '8', '9', '0', '-', '^','\\',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 'o', 'p', '@', '[',0x0d, 'a', 's', 'd',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 'f', 'g', 'h', 'j', 'k', 'l', ';', ':',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 ']', 'z', 'x', 'c', 'v', 'b', 'n', 'm',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 ',', '.', '/',0xff, ' ',0x35,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0x51,0xff,0xff,0xff,0xff,0x62,0x63,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b
	},

	{	//												shift
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '!','\"', '#', '$', '%', '&','\'',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '(', ')', '0', '=', '`', '|',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 'O', 'P', '~', '{',0x0d, 'A', 'S', 'D',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 'F', 'G', 'H', 'J', 'K', 'L', '+', '*',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 '}', 'Z', 'X', 'C', 'V', 'B', 'N', 'M',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 '<', '>', '?', '_', ' ',0xa5,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0xae,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0xa1,0xff,0xff,0xff,0xff,0x82,0x83,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b
	},

	{	//												CAPS
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '1', '2', '3', '4', '5', '6', '7',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '8', '9', '0', '-', '^','\\',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 'O', 'P', '@', '[',0x0d, 'A', 'S', 'D',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 'F', 'G', 'H', 'J', 'K', 'L', ';', ':',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 ']', 'Z', 'X', 'C', 'V', 'B', 'N', 'M',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 ',', '.', '/',0xff, ' ',0x35,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0xa1,0xff,0xff,0xff,0xff,0x62,0x63,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b
	},

	{	//												shift + caps
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '!','\"', '#', '$', '%', '&','\'',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '(', ')', '0', '=', '`', '|',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 'o', 'p', '~', '{',0x0d, 'a', 's', 'd',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 'f', 'g', 'h', 'j', 'k', 'l', '+', '*',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 '}', 'z', 'x', 'c', 'v', 'b', 'n', 'm',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 '<', '>', '?', '_', ' ',0xa5,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0xae,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0xa1,0xff,0xff,0xff,0xff,0x82,0x83,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b
	},

	{	//												kana (+caps)
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '', '', '', '', '', '', '',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '', '', '', '', '', '',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 '', '', '', '', '', '', '', '',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 '', '', '', '',0x0d, '', '', '',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 '', '', '', '', '', '', '', '',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 '', '', '', '', '', '', '', '',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 '', '', '', '', ' ',0x35,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0x3e,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0x51,0xff,0xff,0xff,0xff,0x62,0x63,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b
	},

	{	//												kana + shift (+caps)
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b, '', '', '', '', '', '', '',
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			 '', '', '', '', '', '',0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			 '', '', '', '', '', '', '', '',
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			 '', '', '', '',0x0d, '', '', '',
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			 '', '', '', '', '', '', '', '',
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			 '', '', '', '', '', '', '', '',
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			 '', '', '', '', ' ',0xa5,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0xae,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0xa1,0xff,0xff,0xff,0xff,0x82,0x83,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b
	},

	{	//												grph
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b,0xff,0xff,0xff,0xff,0xf2,0xf3,0xf4,
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			0xf5,0xf6,0xf7,0x8c,0x8b,0xf1,0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			0x9c,0x9d,0xe4,0xe5,0xee,0xef,0xf0,0xe8,
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			0xe9,0x8d,0x8a,0xff,0x0d,0x9e,0x9f,0xe6,
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			0xe7,0xec,0xed,0xea,0xeb,0x8e,0x89,0x94,
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			0xff,0x80,0x81,0x82,0x83,0x84,0x85,0x86,
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			0x87,0x88,0x97,0xff,0x20,0x35,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/',0x98,0x91,0x99,0x95,0xe1,0xe2,
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			0xe3,0xe0,0x93,0x8f,0x92,0x96,0x9a,0x90,
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			0x9b,0x51,0xff,0xff,0xff,0xff,0xff,0xff,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
	},

	{	//												ctrl
		//	 ESC,  P,  Q,  R,  S,  T,  U,  V		; 00h
			0x1b,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		//	  W,  X,  O,  |,  O,  ,  BS, TAB		; 08h
			0xff,0xff,0xff,0xff,0x1e,0x1c,0x08,0x09,
		//	  p,  v,  d,  q,  s,  x,  t,  h		; 10h
			0x11,0x17,0x05,0x12,0x14,0x19,0x15,0x09,
		//	  n,  o,  ,  m, Ret,  `,  r,  c		; 18h
			0x0f,0x10,0x00,0x1b,0x0d,0x01,0x13,0x04,
		//	  e,  f,  g,  i,  j,  k,  G,  F		; 20h
			0x06,0x07,0x08,0x0a,0x0b,0x0c,0xff,0xff,
		//    n,  y,  w,  b,  u,  a,  m,  l		; 28h
			0x1d,0x1a,0x18,0x03,0x16,0x02,0x0e,0x0d,
		//    C,  D,  ^,  Q, SPC,XFER,RLUP,RLDN		; 30h
			0xff,0xff,0xff,0x1f,0x20,0xb5,0x00,0x00,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,
		//	<|>,<^>,<V>,<W>,<X>,<>,<S>,<T>		; 40h
			 '-', '/', '7', '8', '9', '*', '4', '5',
		//	<U>,<{>,<P>,<Q>,<R>,<>,<O>,<C>		; 48h
			 '6', '+', '1', '2', '3', '=', '0', ',',
		//	<D>,NFER,    ,    ,    ,    , f.1, f.2		; 50h
			 '.',0xb1,0xff,0xff,0xff,0xff,0x92,0x93,
		//	 f.3, f.4, f.5, f.6, f.7, f.8, f.9, f.10	; 58h
			0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b
	}
};


void bios0x09_init(void) {

	ZeroMemory(&mem[0x00502], 0x20);
	ZeroMemory(&mem[0x00528], 0x13);
	MEM_KB_SHIFT_TBL = 0x0e00;
	MEM_KB_BUF_HEAD = 0x0502;
	MEM_KB_BUF_TAIL = 0x0502;
	MEM_KB_CODE_OFF = 0x0e00;
	MEM_KB_CODE_SEG = 0xfd00;
}


static void shiftkey(void) {

	WORD	base;

	mem[0xa3ff6] &= 0x3f;							// KEYBOARD LED
	mem[0xa3ff6] |= MEM_SHIFT_STS << 5;
	if (MEM_SHIFT_STS & 0x10) {
		base = 7;
	}
	else if (MEM_SHIFT_STS & 0x08) {
		base = 6;
	}
	else {
		base = MEM_SHIFT_STS & 7;
		if (base >= 6) {
			base -= 2;
		}
	}
	MEM_KB_SHIFT_TBL = (base * 0x60) + 0x0e00;
}



void bios0x09(void) {

	BYTE	key;
	WORD	pos;
	BYTE	bit;
	WORD	code = 0xffff;
	DWORD	base;

	key = keyboard_r(0x41);

	bit = 1 << (key & 7);
	pos = (key & 0x7f) >> 3;
	if (key & 0x80) {
		mem[0x0052a + pos] &= ~bit;
	}
	else {
		mem[0x0052a + pos] |= bit;
	}

	if (!(key & 0x80)) {
		base = 0xfd000 + MEM_KB_SHIFT_TBL;
		if (key <= 0x51) {
			if ((key == 0x51) || (key == 0x35) || (key == 0x3e)) {
				code = (WORD)mem[base + key] << 8;
				if (code == 0xff00) {
					code = 0xffff;
				}
			}
			else {
				code = mem[base + key];
				if (code != 0xff) {
					code |= (WORD)key << 8;
				}
				else {
					code = 0xffff;
				}
			}
		}
		else if (key < 0x60) {
			if (key == 0x5e) {								// home
				code = 0xae00;
			}
		}
		else {
			if (key == 0x60) {
				i286_interrupt(6);
			}
			else if (key == 0x61) {
				i286_interrupt(5);
			}
			else if (key < 0x70) {
				code = (WORD)mem[base + key - 0x0c] << 8;
				if (code == 0xff00) {
					code = 0xffff;
				}
			}
			else if (key < 0x75) {
				MEM_SHIFT_STS |= bit;
				shiftkey();
			}
		}
	}
	else {
		if ((key >= 0xf0) && (key < 0xf5)) {
			MEM_SHIFT_STS &= ~bit;
			shiftkey();
		}
	}

	if (code != 0xffff) {
		if (MEM_KB_COUNT < 0x10) {
			MEM_KB_COUNT++;
			*(WORD *)(&mem[MEM_KB_BUF_TAIL]) = code;
			MEM_KB_BUF_TAIL += 2;
			if (MEM_KB_BUF_TAIL >= 0x522) {
				MEM_KB_BUF_TAIL = 0x502;
			}
		}
	}
	pic_w(0, 0x20);
}



// Win32BIOS̃F킹
void nowkeystat2biosbuf(void) {

	int		i, j;
	BYTE	bit;

	ZeroMemory(&mem[0x0052a], 0x11);
	for (i=0, j=0; j<0x10; j++) {
		for (bit=0x01; bit; bit<<=1, i++) {
			if (keyb.stat[i]) {
				mem[0x0052a + j] |= bit;
			}
		}
	}
	mem[0x0053a] = mem[0x00538];
}
