#include	<windows.h>
#include	<time.h>
#include	"common.h"
#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"itimer.h"
#include	"parts.h"
#include	"pic.h"


void bios0x1c_03(void) {

	itimer_w(0x71, 0x00);
	if (pc.cpumode & CPUMODE_8MHz) {
		itimer_w(0x71, 0x4e);				// 4MHz
	}
	else {
		itimer_w(0x71, 0x60);				// 5MHz
	}
	pic[0].imr &= ~(PIC_SYSTEMTIMER);
}


void bios0x1c(void) {

	switch(I286_AH) {
		case 0x00:					// get system timer
			{
				char		buf[6];
				time_t		ltime;
				struct tm	*nt;

				time(&ltime);
				nt = localtime(&ltime);
				buf[0] = AdjustAfterMultiply((BYTE)(nt->tm_year % 100));
				buf[1] = (BYTE)(((nt->tm_mon + 1) << 4) + nt->tm_wday);
				buf[2] = AdjustAfterMultiply(nt->tm_mday);
				buf[3] = AdjustAfterMultiply(nt->tm_hour);
				buf[4] = AdjustAfterMultiply(nt->tm_min);
				buf[5] = AdjustAfterMultiply(nt->tm_sec);
				i286_memstr_write(I286_ES, I286_BX, buf, 6);
			}
			break;

		case 0x01:					// put system timer
			break;

		case 0x02:					// set interval timer (single)
			*(WORD *)(&mem[0x0001c]) = I286_BX;
			*(WORD *)(&mem[0x0001e]) = I286_ES;
			*(WORD *)(&mem[0x0058a]) = I286_CX;
			itimer_w(0x77, 0x36);

		case 0x03:					// continue interval timer
			bios0x1c_03();
			break;
	}
}

