#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	<ddraw.h>

#include	"common.h"
#include	"resource.h"
#include	"np2.h"
#include	"pc_core.h"
#include	"ddraws.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"ini.h"
#include	"winmouse.h"

static	RECT	rect200 = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
static	RECT	rectdraw1 = {0, 0, SCREEN_WIDTH, 1};
extern	HWND	hWndMain;

static	LPDIRECTDRAW			pDDraw1 = NULL;
static	LPDIRECTDRAW2			pDDraw = NULL;
static	LPDIRECTDRAWSURFACE		pPrimSurf = NULL;
static	LPDIRECTDRAWSURFACE		pBackSurf = NULL;
static	LPDIRECTDRAWCLIPPER		pClipper = NULL;
static	LPDIRECTDRAWPALETTE		pPalette = NULL;
static	PALETTEENTRY			winpal[256];
static	BYTE					allflash = 0;

static	BYTE	palchanged = 0;
static	BYTE	setscmd = 0;
		BYTE	SCREENMODE = 0;
		BYTE	drawingmode = 0;

		int				np2_palettes = 0;
		PALETTE_TABLE	np2_palette[256];
		BYTE			renewal_line[SCREEN_HEIGHT+4];
		WORD			np2_pal16[256];

		WORD			np2_r16b;
		WORD			np2_r16r;
		WORD			np2_r16g;
		WORD			np2_l16b;
		WORD			np2_l16r;
		WORD			np2_l16g;

		BYTE			np2_tram[0x40000];
		BYTE			np2_vram[2][0x40000];

extern	int				winx, winy;
static	int				winw = 640;
static	int				winh = 400;

__inline void fillrenewalline(DWORD value) {

	int		cnt = SCREEN_HEIGHT / 4;
	DWORD	*p = (DWORD *)renewal_line;
	while(cnt--) {
		*p++ |= value;
	}
}

void np2_initwindowsize(WORD width, WORD height) {

	RECT	rectWindow, rectClient;
	int		scx, scy;

	GetWindowRect(hWndMain, &rectWindow);
	GetClientRect(hWndMain, &rectClient);
	winw = width + (rectWindow.right - rectWindow.left)
					- (rectClient.right - rectClient.left);
	winh = height + (rectWindow.bottom - rectWindow.top)
					- (rectClient.bottom - rectClient.top);

	scx = GetSystemMetrics(SM_CXSCREEN);
	scy = GetSystemMetrics(SM_CYSCREEN);

	if (scx < winw) {
		INIT_RENEWAL
			winx = (scx - winw) / 2;
	}
	else if (winx < 0) {
		INIT_RENEWAL
			winx = 0;
	}
	else if ((winx + winw) > scx) {
		INIT_RENEWAL
			winx = scx - winw;
	}
	if (scy < winh) {
		INIT_RENEWAL
			winy = (scy - winh) / 2;
	}
	else if (winy < 0) {
		INIT_RENEWAL
			winy = 0;
	}
	else if ((winy + winh) > scy) {
		INIT_RENEWAL
			winy = scy - winh;
	}
}



BYTE np2_setscreenmode(BYTE mode) {

	BYTE	ret = FALSE;

	if (mode & SCMD_SETWINDOWED) {
		if (!(SCREENMODE & SCMD_WINDOWED)) {
			setscmd |= SCMD_SETWINDOWED;
			ret = TRUE;
		}
	}
	else if (mode & SCMD_SETFULLSCREEN) {
		if (!(SCREENMODE & SCMD_FULLSCRN)) {
			setscmd &= (~SCMD_SETWINDOWED);
			ret = TRUE;
		}
	}
	if (mode & SCMD_SET256) {
		if (!(SCREENMODE & SCMD_USEPAL)) {
			setscmd |= SCMD_SET256;
			ret = TRUE;
		}
	}
	else if (mode & SCMD_SET65536) {
		if (!(SCREENMODE & SCMD_NONPAL)) {
			setscmd &= (~SCMD_SET256);
			ret = TRUE;
		}
	}
	return(ret);
}


void np2_windowstats(void) {

	DWORD	winstyle, winstyleex;
	HMENU	hmenu = GetMenu(hWndMain);

	winstyle = GetWindowLong(hWndMain, GWL_STYLE);
	winstyleex = GetWindowLong(hWndMain, GWL_EXSTYLE);
	if (setscmd & SCMD_SETWINDOWED) {
		winstyle = (winstyle | WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU)
																& ~WS_POPUP;
		winstyleex &= ~WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);

		MoveWindow(hWndMain, winx, winy, winw, winh, TRUE);

		CheckMenuItem(hmenu, IDM_WINDOW, MF_CHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_UNCHECKED);
	}
	else {
		winstyle = (winstyle | WS_POPUP)
						& (~(WS_CAPTION | WS_OVERLAPPED | WS_SYSMENU));
		winstyleex |= WS_EX_TOPMOST;
		SetWindowLong(hWndMain, GWL_STYLE, winstyle);
		SetWindowLong(hWndMain, GWL_EXSTYLE, winstyleex);
		CheckMenuItem(hmenu, IDM_WINDOW, MF_UNCHECKED);
		CheckMenuItem(hmenu, IDM_FULLSCREEN, MF_CHECKED);
	}
}


void np2_wincenter(void) {

	INIT_RENEWAL
		winx = (GetSystemMetrics(SM_CXSCREEN) - winw) / 2;
		winy = (GetSystemMetrics(SM_CYSCREEN) - winh) / 2;
	MoveWindow(hWndMain, winx, winy, winw, winh, TRUE);
}


void ddraws_init(void) {


	ZeroMemory(np2_tram, sizeof(np2_tram));
	ZeroMemory(np2_vram, sizeof(np2_vram));
	ZeroMemory(np2_palette, sizeof(np2_palette));
	np2_palettes = 0;
	allflash = 1;
	fillrenewalline(0x80808080);
}

WORD ddraw16bitpal(PALETTE_TABLE pal) {

	return(((pal.b.red >> np2_r16r) << np2_l16r) |
			((pal.b.green >> np2_r16g) << np2_l16g) |
			((pal.b.blue >> np2_r16b) << np2_l16b));
}


void change_palette(int setpals) {

	int		i;

	if (SCREENMODE & SCMD_USEPAL) {
		palchanged = 1;
	}
	else {
		if ((SCREENMODE & SCMD_COLORMASK) == SCMD_COLOR16) {
			for (i=0; i<setpals; i++) {
				np2_pal16[i] =
						((np2_palette[i].b.red >> np2_r16r) << np2_l16r) |
						((np2_palette[i].b.green >> np2_r16g) << np2_l16g) |
						((np2_palette[i].b.blue >> np2_r16b) << np2_l16b);
			}
		}
		fillrenewalline(0x80808080);
	}
}


static void palette_init(void) {

	BYTE	i;
	HDC 	hdc = GetDC(hWndMain);

	GetSystemPaletteEntries(hdc, 0, 256, winpal);
	ReleaseDC(hWndMain, hdc);

	for (i=START_PAL; i<(START_PAL + TOTAL_PALS); i++) {
		winpal[i].peFlags = PC_RESERVED | PC_NOCOLLAPSE;
	}
//	reflesh_palette();
	IDirectDraw2_CreatePalette(pDDraw, DDPCAPS_8BIT, winpal, &pPalette, 0);
	IDirectDrawSurface_SetPalette(pPrimSurf, pPalette);
	palchanged = 0;
}


static void palette_set(void) {

	int		i;

	if ((pPalette != NULL) && (np2_palettes)) {
		for (i=0; i<np2_palettes; i++) {
			winpal[i+START_PAL].peRed = np2_palette[i].b.red;
			winpal[i+START_PAL].peBlue = np2_palette[i].b.blue;
			winpal[i+START_PAL].peGreen = np2_palette[i].b.green;
		}
		IDirectDrawPalette_SetEntries(pPalette, 0, START_PAL, np2_palettes, &winpal[START_PAL]);
	}
}


void clearblankarea(void) {

	DDBLTFX		ddbf;
	RECT		fill1rect = {0, 0, FULLSCREEN_WIDTH, FULLSCREEN_POSY};
	RECT		fill2rect = {0, FULLSCREEN_HEIGHT - FULLSCREEN_POSY,
								FULLSCREEN_WIDTH, FULLSCREEN_HEIGHT};

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	IDirectDrawSurface_Blt(pPrimSurf, &fill1rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
	IDirectDrawSurface_Blt(pPrimSurf, &fill2rect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
}

static void make16bit(WORD *shlcnt, WORD *shrcnt, DWORD bitmap) {

	WORD	bit = 1;
	WORD	cnt;

	for (cnt=0; (cnt<16) && (!(bitmap & bit)); cnt++, bit<<=1) ;
	*shlcnt = cnt;
	for (cnt=8; (cnt) && (bitmap & bit); cnt--, bit<<=1) ;
	*shrcnt = cnt;
}


int np2_InitDirectDraw(void) {

	DDSURFACEDESC	ddsd;
	DDPIXELFORMAT	ddpf;
	int				bitcolor;

	pDDraw1 = NULL;
	pDDraw = NULL;
	pPrimSurf = NULL;
	pBackSurf = NULL;
	pClipper = NULL;
	pPalette = NULL;
	palchanged = 0;
	SCREENMODE = 0;

	if (FAILED(DirectDrawCreate(NULL, &pDDraw1, NULL))) {
		return(FAILURE);
	}
	IDirectDraw_QueryInterface(pDDraw1, &IID_IDirectDraw2, &pDDraw);

	if (setscmd & SCMD_SETWINDOWED) {
		IDirectDraw2_SetCooperativeLevel(pDDraw, hWndMain, DDSCL_NORMAL);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

		if (FAILED(IDirectDraw2_CreateSurface(pDDraw, &ddsd, &pPrimSurf, NULL))) {
			return(FAILURE);
		}

		IDirectDraw2_CreateClipper(pDDraw, 0, &pClipper, NULL);
		IDirectDrawClipper_SetHWnd(pClipper, 0, hWndMain);
		IDirectDrawSurface_SetClipper(pPrimSurf, pClipper);

		ZeroMemory(&ddpf, sizeof(ddpf));
		ddpf.dwSize = sizeof(DDPIXELFORMAT);
		if (FAILED(IDirectDrawSurface_GetPixelFormat(pPrimSurf, &ddpf))) {
			return(FAILURE);
		}

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = SCREEN_WIDTH;
		ddsd.dwHeight = SCREEN_HEIGHT;

		if (FAILED(IDirectDraw2_CreateSurface(pDDraw, &ddsd, &pBackSurf, NULL))) {
			return(FAILURE);
		}
		if (ddpf.dwRGBBitCount == 8) {
			SCREENMODE |= SCMD_WINDOW8;
			palette_init();
		}
		else if (ddpf.dwRGBBitCount == 16) {
			SCREENMODE |= SCMD_WINDOW16;
			make16bit(&np2_l16b, &np2_r16b, ddpf.dwBBitMask);
			make16bit(&np2_l16r, &np2_r16r, ddpf.dwRBitMask);
			make16bit(&np2_l16g, &np2_r16g, ddpf.dwGBitMask);
//			reflesh_palette();
		}
		else if (ddpf.dwRGBBitCount == 24) {
			SCREENMODE |= SCMD_WINDOW24;
//			reflesh_palette();
		}
		else if (ddpf.dwRGBBitCount == 32) {
			SCREENMODE |= SCMD_WINDOW32;
//			reflesh_palette();
		}
		else {
			return(FAILURE);
		}
	}
	else {
		IDirectDraw2_SetCooperativeLevel(pDDraw, hWndMain,
					DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
		if (setscmd & SCMD_SET256) {
			bitcolor = 8;
		}
		else {
			bitcolor = 16;
		}
		if (FAILED(IDirectDraw2_SetDisplayMode(pDDraw, FULLSCREEN_WIDTH,
										FULLSCREEN_HEIGHT, bitcolor, 0, 0))) {
			return(FAILURE);
		}
		IDirectDraw2_CreateClipper(pDDraw, 0, &pClipper, NULL);
		IDirectDrawClipper_SetHWnd(pClipper, 0, hWndMain);

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
		if (FAILED(IDirectDraw2_CreateSurface(pDDraw, &ddsd, &pPrimSurf, NULL))) {
			return(FAILURE);
		}
		clearblankarea();

		ZeroMemory(&ddpf, sizeof(ddpf));
		ddpf.dwSize = sizeof(DDPIXELFORMAT);
		if (FAILED(IDirectDrawSurface_GetPixelFormat(pPrimSurf, &ddpf))) {
			return(FAILURE);
		}

		ZeroMemory(&ddsd, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
		ddsd.dwWidth = FULLSCREEN_WIDTH;
		ddsd.dwHeight = SCREEN_HEIGHT;
		if (FAILED(IDirectDraw2_CreateSurface(pDDraw, &ddsd, &pBackSurf, NULL))) {
			return(FAILURE);
		}
		if (bitcolor == 8) {
			SCREENMODE |= SCMD_FSCREEN8;
			palette_init();
		}
		else {
			SCREENMODE |= SCMD_FSCREEN16;
			change_palette(np2_palettes);
			make16bit(&np2_l16b, &np2_r16b, ddpf.dwBBitMask);
			make16bit(&np2_l16r, &np2_r16r, ddpf.dwRBitMask);
			make16bit(&np2_l16g, &np2_r16g, ddpf.dwGBitMask);
//			reflesh_palette();
		}
	}
	return(SUCCESS);
}


void np2_TermDirectDraw(void) {

	if ((SCREENMODE & SCMD_FULLSCRN) && (pDDraw)) {
//		pDDraw->RestoreDisplayMode();
		IDirectDraw2_SetCooperativeLevel(pDDraw, hWndMain, DDSCL_NORMAL);
	}
	if (pBackSurf) IDirectDrawSurface_Release(pBackSurf);
	if (pPalette) IDirectDrawPalette_Release(pPalette);
	if (pClipper) IDirectDrawClipper_Release(pClipper);
	if (pPrimSurf) IDirectDrawSurface_Release(pPrimSurf);
	if (pDDraw) IDirectDraw2_Release(pDDraw);
	if (pDDraw1) IDirectDraw_Release(pDDraw1);
	pBackSurf = NULL;
	pPalette = NULL;
	pClipper = NULL;
	pPrimSurf = NULL;
	pDDraw = NULL;
	pDDraw1 = NULL;
}

void change_drawlines(DWORD lines) {

	if (lines > SCREEN_HEIGHT) {
		lines = SCREEN_HEIGHT;
	}
	rect200.bottom = lines;
	allflash = 1;
}

void clearblanklines(DWORD posx, DWORD posy) {

	DDBLTFX		ddbf;
	RECT		fillrect;

	fillrect.left = posx;
	fillrect.top = posy + rect200.bottom;
	fillrect.right = posx + SCREEN_WIDTH;
	fillrect.bottom = posy + SCREEN_HEIGHT;

	ZeroMemory(&ddbf, sizeof(ddbf));
	ddbf.dwSize = sizeof(ddbf);
	ddbf.dwFillColor = 0;
	IDirectDrawSurface_Blt(pPrimSurf, &fillrect, NULL, NULL, DDBLT_COLORFILL, &ddbf);
}



	DDSURFACEDESC	destscrn;

LABEL void __fastcall drawplane1(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, ecx
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
x1win8bppdrlp1:			test	renewal_line[ebx], dl
						je		x1win8bppdred
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH / 4
x1win8bppdrlp2:			mov		eax, [esi]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		edi, 4
						loop	x1win8bppdrlp2
						pop		edi
						pop		esi
x1win8bppdred:			add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdrlp1
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdred
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win16bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						add		edi, 2
						loop	x1win16bppdrlp2
						pop		edi
						pop		esi
x1win16bppdred:			add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdred
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH - 1
x1win24bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 3
						loop	x1win24bppdrlp2
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], AX
						pop		edi
						pop		esi
x1win24bppdred:			add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdred
						and		renewal_line[ebx], dh
						push	esi
						push	edi
						mov		ecx, SCREEN_WIDTH
x1win32bppdrlp2:		movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						add		edi, 4
						loop	x1win32bppdrlp2
						pop		edi
						pop		esi
x1win32bppdred:			add		esi, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}


LABEL void __fastcall drawplanet1(void *srcscreen, BYTE bit) {

		__asm {
				pushad
				mov		esi, offset np2_tram
				mov		edi, destscrn.lpSurface
				xor		ebx, ebx
				mov		dh, dl
				not		dh

				mov		al, SCREENMODE
				and		al, SCMD_COLORMASK
				je		draw_color32						// 32bit
				dec		al
				je		draw_color24						// 24bit
				dec		al
				je		draw_color16						// 16bit

															// 8bit
x1win8bppdrlp1:			test	renewal_line[ebx], dl
						je		x1win8bppdred
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH / 4
x1win8bppdrlp2:			mov		eax, [esi]
						or		eax, [ecx]
						add		eax, (0x01010101 * START_PAL)
						mov		[edi], eax
						add		esi, 4
						add		ecx, 4
						add		edi, 4
						dec		ebp
						jne		x1win8bppdrlp2
						pop		edi
						pop		esi
						pop		ecx
x1win8bppdred:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		x1win8bppdrlp1
						jmp		draw_color_ed

draw_color16:			test	renewal_line[ebx], dl
						je		x1win16bppdred
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win16bppdrlp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		ax, word ptr np2_pal16[eax*2]
						mov		[edi], ax
						inc		esi
						inc		ecx
						add		edi, 2
						dec		ebp
						jne		x1win16bppdrlp2
						pop		edi
						pop		esi
						pop		ecx
x1win16bppdred:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color16
						jmp		draw_color_ed

draw_color24:			test	renewal_line[ebx], dl
						je		x1win24bppdred
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH - 1
x1win24bppdrlp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 3
						dec		ebp
						jne		x1win24bppdrlp2
						movzx	eax, byte ptr [esi]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], al
						shr		eax, 8
						mov		[edi+1], AX
						pop		edi
						pop		esi
						pop		ecx
x1win24bppdred:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color24
						jmp		draw_color_ed

draw_color32:			test	renewal_line[ebx], dl
						je		x1win32bppdred
						and		renewal_line[ebx], dh
						push	ecx
						push	esi
						push	edi
						mov		ebp, SCREEN_WIDTH
x1win32bppdrlp2:		movzx	eax, byte ptr [esi]
						or		al, [ecx]
						mov		eax, dword ptr np2_palette[eax*4]
						mov		[edi], eax
						inc		esi
						inc		ecx
						add		edi, 4
						dec		ebp
						jne		x1win32bppdrlp2
						pop		edi
						pop		esi
						pop		ecx
x1win32bppdred:			add		esi, SCREEN_WIDTH
						add		ecx, SCREEN_WIDTH
						add		edi, destscrn.lPitch
						inc		ebx
						cmp		ebx, SCREEN_HEIGHT
						jc		draw_color32

draw_color_ed:	popad
				ret
		}
}

void scrn_draws(int redraw) {

	BYTE	bit = 0;

	if (redraw) {
		fillrenewalline(0x80808080);
	}

	if (gdcs.textdisp & 0x80) {
		bit |= 4;
	}
	if (gdcs.grphdisp & 0x80) {
		bit |= (1 << gdcs.disp);
	}

	if (bit) {
		ZeroMemory(&destscrn, sizeof(destscrn));
		destscrn.dwSize = sizeof(destscrn);
		if (IDirectDrawSurface_Lock(pBackSurf, NULL, &destscrn, DDLOCK_WAIT, NULL) == DD_OK) {
			switch(bit & 7) {
				case 1:
					drawplane1(np2_vram[0], 0x81);
					break;
				case 2:
					drawplane1(np2_vram[1], 0x82);
					break;
				case 4:
					drawplane1(np2_tram, 0x84);
					break;
				case 5:
					drawplanet1(np2_vram[0], 0x85);
					break;
				case 6:
					drawplanet1(np2_vram[1], 0x86);
					break;
			}
			IDirectDrawSurface_Unlock(pBackSurf, NULL);
		}
	}
	else {
		DDBLTFX		ddbf;
		ZeroMemory(&ddbf, sizeof(ddbf));
		ddbf.dwSize = sizeof(ddbf);
		IDirectDrawSurface_Blt(pBackSurf, &rect200, NULL, NULL, DDBLT_COLORFILL, &ddbf);
	}
}



void scrn_drawall(void) {

	POINT	pt;
	RECT	rectDst;

	if (SCREENMODE & SCMD_USEPAL) {
		if (palchanged) {
			palchanged = 0;
			palette_set();
		}
	}
	if (pBackSurf != NULL) {
		if (SCREENMODE & SCMD_FULLSCRN) {
			if (IDirectDrawSurface_BltFast(pPrimSurf, 0, FULLSCREEN_POSY,
					pBackSurf, &rect200, DDBLTFAST_WAIT) == DDERR_SURFACELOST) {
				IDirectDrawSurface_Restore(pPrimSurf);
				IDirectDrawSurface_Restore(pBackSurf);
			}
			if (allflash) {
				allflash = 0;
				clearblanklines(0, FULLSCREEN_POSY);
			}
		}
		else {
			pt.x = 0;
			pt.y = 0;
			ClientToScreen(hWndMain, &pt);
			SetRect(&rectDst, pt.x, pt.y, pt.x + SCREEN_WIDTH,
								pt.y + rect200.bottom);
			if (IDirectDrawSurface_Blt(pPrimSurf, &rectDst, pBackSurf, &rect200,
									DDBLT_WAIT, NULL) == DDERR_SURFACELOST) {
				IDirectDrawSurface_Restore(pPrimSurf);
				IDirectDrawSurface_Restore(pBackSurf);
			}
			if (allflash) {
				allflash = 0;
				clearblanklines(pt.x, pt.y);
			}
		}
	}
}

BYTE scrn_restore(void) {

	if (IDirectDrawSurface_IsLost(pBackSurf) == DDERR_SURFACELOST) {
		IDirectDrawSurface_Restore(pBackSurf);
		allflash = 1;
		fillrenewalline(0x80808080);
		return(1);
	}
	return(0);
}

void scrn_palette(void) {

	if (pPalette) {
		IDirectDrawSurface_SetPalette(pPrimSurf, pPalette);
	}
}


void mx_topwinui(void) {

	mouse_running(MOUSE_STOP);
	if (!(SCREENMODE & SCMD_WINDOWED)) {
#if 1
		IDirectDraw2_FlipToGDISurface(pDDraw);
#endif
		IDirectDrawSurface_SetClipper(pPrimSurf, pClipper);
	}
}

void mx_clearwinui(void) {

	if (!(SCREENMODE & SCMD_WINDOWED)) {
		IDirectDrawSurface_SetClipper(pPrimSurf, 0);
		clearblankarea();
	}
	mouse_running(MOUSE_CONT);
}


void ddraws_redraw(void) {

	allflash = 1;
	palchanged = 1;
	palettes(1);
	scrn_draws(1);
	scrn_drawall();
}

