
#define	NEKO

#include	<windows.h>
#include	"fddfile.h"
#include	"fdd_xdf.h"

#ifdef KEROPI
#include	"../win32/common.h"
#include	"../win32/fileio.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	File_Open
#define		FILE_READ	File_Read
#define		FILE_SEEK	File_Seek
#define		FILE_CLOSE	File_Close
#endif

#ifdef NEKO
#include	"common.h"
#include	"np2.h"
#include	"dosio.h"
#include	"iobridge.h"
#include	"fdc.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	file_open
#define		FILE_READ	file_read
#define		FILE_WRITE	file_write
#define		FILE_SEEK	file_seek
#define		FILE_CLOSE	file_close
#endif


#define		SECTORS		8
#define		SECTORN		3
#define		SECTORSIZE	(128 << SECTORN)


BOOL fdd_set_xdf(BYTE drv, LPSTR fname) {

	WORD	attr;
	FILEH	fh;

	if ((attr = file_attr(fname)) & 0x18) {
		return(FAILURE);
	}
	if ((fh = file_open(fname)) == (FILEH)-1) {
		return(FAILURE);
	}
	if (file_seek(fh, 0, FSEEK_END) != (1024*8*154)) {
		file_close(fh);
		return(FAILURE);
	}
	file_close(fh);
	strcpy(fddfile[drv].fname, fname);
	fddfile[drv].type = DISKTYPE_BETA;
	fddfile[drv].protect = (BYTE)(attr & 1);
	return(0);
}


BOOL fdd_eject_xdf(BYTE drv) {

	fddfile[drv].fname[0] = '\0';
	fddfile[drv].type = DISKTYPE_NOTREADY;
	return(SUCCESS);
}


BOOL fdd_diskaccess_xdf(void) {

	if (CTRL_FDMEDIA != DISKTYPE_2HD) {
		return(FAILURE);
	}
	return(SUCCESS);
}

BOOL fdd_seek_xdf(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fddfile[fdc.us].type != DISKTYPE_BETA) ||
		(CTRL_FDMEDIA != DISKTYPE_2HD) ||
		(fdc.ncn >= 76)) {
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_seeksector_xdf(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fddfile[fdc.us].type != DISKTYPE_BETA) ||
		(CTRL_FDMEDIA != DISKTYPE_2HD) ||
		(fdc.treg[fdc.us] >= 76) || (!fdc.R) || (fdc.R > SECTORS)) {
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_read_xdf(void) {

	FILEHDL	hdl;
	DWORD	seekp;

	if ((fdd_seeksector_xdf()) || (fdc.N != SECTORN)) {
		return(FAILURE);
	}
	seekp = (((fdc.treg[fdc.us] << 1) + fdc.hd)
						* SECTORS + fdc.R - 1) * SECTORSIZE;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_READ(hdl, fdc.buf, SECTORSIZE) != SECTORSIZE)) {
		FILE_CLOSE(hdl);
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = SECTORSIZE;
	return(SUCCESS);
}


BOOL fdd_write_xdf(void) {

	FILEHDL	hdl;
	DWORD	seekp;

	if ((fdd_seeksector_xdf()) ||
		(fddfile[fdc.us].protect) || (fdc.N != SECTORN)) {
		return(FAILURE);
	}

	seekp = (((fdc.treg[fdc.us] << 1) + fdc.hd)
						* SECTORS + fdc.R - 1) * SECTORSIZE;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_WRITE(hdl, fdc.buf, SECTORSIZE) != SECTORSIZE)) {
		FILE_CLOSE(hdl);
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = SECTORSIZE;
	return(SUCCESS);
}

BOOL fdd_readid_xdf(void) {

	if (fdc.crcn >= SECTORS) {
		return(FAILURE);
	}
	fdc.C = fdc.treg[fdc.us];
	fdc.H = fdc.hd;
	fdc.R = ++fdc.crcn;
	fdc.N = SECTORN;
	return(SUCCESS);
}

