
#define	NEKO

#include	<windows.h>
#include	"fddfile.h"
#include	"fdd_fdi.h"

#ifdef KEROPI
#include	"../win32/common.h"
#include	"../win32/fileio.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	File_Open
#define		FILE_READ	File_Read
#define		FILE_SEEK	File_Seek
#define		FILE_CLOSE	File_Close
#endif

#ifdef NEKO
#include	"common.h"
#include	"np2.h"
#include	"dosio.h"
#include	"iobridge.h"
#include	"fdc.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	file_open
#define		FILE_READ	file_read
#define		FILE_WRITE	file_write
#define		FILE_SEEK	file_seek
#define		FILE_CLOSE	file_close
#endif

#define		SECTORN		3

typedef struct {
	DWORD x00;
	DWORD x04;
	DWORD header_size;
	DWORD image_size;
	DWORD sector_size;
	DWORD sector;
	DWORD head;
	DWORD track;
} FDI_HEADER;
static FDI_HEADER fdihead[4];
static BYTE fdimedia[4];

BOOL fdd_set_fdi(BYTE drv, LPSTR fname) {

	DWORD	chk;
	WORD	attr;
	FILEH	fh;

	if ((attr = file_attr(fname)) & 0x18) {
		return(FAILURE);
	}
	if ((fh = FILE_OPEN(fname)) == (FILEH)-1) {
		return(FAILURE);
	}
	if (FILE_READ(fh, &fdihead[drv], sizeof(FDI_HEADER)) != sizeof(FDI_HEADER)) {
		return(FAILURE);
	}
	FILE_CLOSE(fh);
	chk = fdihead[drv].track * fdihead[drv].head * fdihead[drv].sector * fdihead[drv].sector_size;
	if (chk != 0 && fdihead[drv].image_size == chk) {
		switch (chk) {
			default:
				return(FAILURE);
			case 1024*8*2*77:		/* 1,261,568Bytes(1.232MB) 2HD */
			case 512*15*2*80:		/* 1,213,952Bytes(1.2MB) 2HC */
				fdimedia[drv] = DISKTYPE_2HD;
				break;
			case 512*36*2*80:		/* 2,949,120Bytes(2.88MB) 2ED */
			case 512*18*2*80:		/* 1,474,560Bytes(1.44MB) 2HD */
				fdimedia[drv] = DISKTYPE_14M;
				break;
			case 512*9*2*80:		/* 737,280Bytes(720KB) 2DD/9 */
			case 512*8*2*80:		/* 655,360Bytes(640KB) 2DD/8 */
				fdimedia[drv] = DISKTYPE_2DD;
				break;
			case 512*9*2*40:		/* 368,640Bytes(360KB) 2D/9 */
			case 512*8*2*40:		/* 327,680Bytes(320KB) 2D/8 */
				fdimedia[drv] = DISKTYPE_2D;
				break;
		}
	} else {
		chk = FILE_SEEK(fh, 0, FSEEK_END);
		switch (chk) {
			default:
				return(FAILURE);
			case 1024*8*2*77:	/* 1,261,568Bytes(1.232MB) 2HD */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=1024;
				fdihead[drv].sector=8;
				fdihead[drv].head=2;
				fdihead[drv].track=77;
				fdimedia[drv] = DISKTYPE_2HD;
				break;
			case 512*15*2*80:	/* 1,213,952Bytes(1.2MB) 2HC */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=15;
				fdihead[drv].head=2;
				fdihead[drv].track=80;
				fdimedia[drv] = DISKTYPE_2HD;
				break;
			case 512*36*2*80:	/* 2,949,120Bytes(2.88MB) 2ED */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=36;
				fdihead[drv].head=2;
				fdihead[drv].track=80;
				fdimedia[drv] = DISKTYPE_14M;
				break;
			case 512*18*2*80:	/* 1,474,560Bytes(1.44MB) 2HD */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=18;
				fdihead[drv].head=2;
				fdihead[drv].track=80;
				fdimedia[drv] = DISKTYPE_14M;
				break;
			case 512*9*2*80:	/* 737,280Bytes(720KB) 2DD/9 */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=9;
				fdihead[drv].head=2;
				fdihead[drv].track=80;
				fdimedia[drv] = DISKTYPE_2DD;
				break;
			case 512*9*2*40:	/* 368,640Bytes(360KB) 2D/9 */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=9;
				fdihead[drv].head=2;
				fdihead[drv].track=40;
				fdimedia[drv] = DISKTYPE_2D;
				break;
			case 512*8*2*80:	/* 655,360Bytes(640KB) 2DD/8 */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=8;
				fdihead[drv].head=2;
				fdihead[drv].track=80;
				fdimedia[drv] = DISKTYPE_2DD;
				break;
			case 512*8*2*40:	/* 327,680Bytes(320KB) 2D/8 */
				fdihead[drv].header_size=0;
				fdihead[drv].sector_size=512;
				fdihead[drv].sector=8;
				fdihead[drv].head=2;
				fdihead[drv].track=40;
				fdimedia[drv] = DISKTYPE_2D;
				break;
		}
	}
	strcpy(fddfile[drv].fname, fname);
	fddfile[drv].type = DISKTYPE_FDI;
	fddfile[drv].protect = (BYTE)(attr & 1);
	return(0);
}


BOOL fdd_eject_fdi(BYTE drv) {

	fddfile[drv].fname[0] = '\0';
	fddfile[drv].type = DISKTYPE_NOTREADY;
	return(SUCCESS);
}


BOOL fdd_diskaccess_fdi(void) {

	if (CTRL_FDMEDIA != fdimedia[fdc.us]) {
		return(FAILURE);
	}
	return(SUCCESS);
}

BOOL fdd_seek_fdi(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fdc.ncn >= (fdihead[fdc.us].track - 1))) {
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_seeksector_fdi(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fddfile[fdc.us].type != DISKTYPE_FDI) ||
		(fdc.treg[fdc.us] >= (fdihead[fdc.us].track - 1)) ||
		(!fdc.R) || (fdc.R > fdihead[fdc.us].sector)) {
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_read_fdi(void) {

	FILEHDL	hdl;
	DWORD	seekp;

	if ((fdd_seeksector_fdi()) || (fdc.N != SECTORN)) {
		return(FAILURE);
	}
	seekp = (((fdc.treg[fdc.us] << 1) + fdc.hd)
					* fdihead[fdc.us].sector + fdc.R - 1)
					* fdihead[fdc.us].sector_size
					+ fdihead[fdc.us].header_size;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_READ(hdl, fdc.buf, fdihead[fdc.us].sector_size) != fdihead[fdc.us].sector_size)) {
		FILE_CLOSE(hdl);
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = fdihead[fdc.us].sector_size;
	return(SUCCESS);
}


BOOL fdd_write_fdi(void) {

	FILEHDL	hdl;
	DWORD	seekp;

	if ((fdd_seeksector_fdi()) ||
		(fddfile[fdc.us].protect) || (fdc.N != SECTORN)) {
		return(FAILURE);
	}

	seekp = (((fdc.treg[fdc.us] << 1) + fdc.hd)
					* fdihead[fdc.us].sector + fdc.R - 1)
					* fdihead[fdc.us].sector_size
					+ fdihead[fdc.us].header_size;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_WRITE(hdl, fdc.buf, fdihead[fdc.us].sector_size) != fdihead[fdc.us].sector_size)) {
		FILE_CLOSE(hdl);
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = fdihead[fdc.us].sector_size;
	return(SUCCESS);
}

BOOL fdd_readid_fdi(void) {

	if (fdc.crcn >= fdihead[fdc.us].sector) {
		return(FAILURE);
	}
	fdc.C = fdc.treg[fdc.us];
	fdc.H = fdc.hd;
	fdc.R = ++fdc.crcn;
	fdc.N = SECTORN;
	return(SUCCESS);
}

