#include	<windows.h>
#include	<math.h>
#include	"common.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_sub.h"
#include	"makegrph.h"
#include	"memory.h"
#include	"nevent.h"

static	BYTE	*gdcsubp;
static	BYTE	updatebit;
static	WORD	pattern;
static	BYTE	operate;

#define	RT_MULBIT		15
#define	RT_TABLEBIT		12
#define	RT_TABLEMAX		(1 << RT_TABLEBIT)

static	DWORD	gdc_rt[RT_TABLEMAX+1];

void gdcsub_init(void) {

	int		i;

	for (i=0; i<=RT_TABLEMAX; i++) {
		gdc_rt[i] = (WORD)((double)(1 << RT_MULBIT) *
				(1 - sqrt(1 - pow((0.70710678118654 * i) / RT_TABLEMAX, 2))));
	}
}


static BOOL gdcsub_prepart(DWORD csrw, WORD pat, BYTE ope, WORD *x, WORD *y) {

	if (!gdcs.access) {
		gdcsubp = &mem[0x000000];
		updatebit = 1;
	}
	else {
		gdcsubp = &mem[0x200000];
		updatebit = 2;
	}
	gdcs.grphdisp |= updatebit;
	switch((csrw >> 14) & 7) {
		case 1:
			gdcsubp += 0xa8000;
			break;
		case 2:
			gdcsubp += 0xb0000;
			break;
		case 3:
			gdcsubp += 0xb8000;
			break;
		case 4:
			gdcsubp += 0xe0000;
			break;
		default:
			return(FAILURE);
	}
	*y = (WORD)((csrw & 0x3fff) / 40);
	*x = (WORD)((((csrw & 0x3fff) % 40) << 4) + ((csrw >> 20) & 0x0f));
	pattern = pat;
	operate = ope;
	return(SUCCESS);
}

#if 1								// VC++5.0f\[X[o
LABEL static void gdc_REPLACE(void) {

		__asm {
				mov		al, updatebit
				or		[ebx], al
				rol		pattern, 1
				jc		opeset
				btr		word ptr [edx], cx
				pop		ecx
				pop		ebx
				ret
		opeset:	bts		word ptr [edx], cx
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_COMPLEMENT(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				btc		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_CLEAR(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				btr		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_SET(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				bts		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

						//  rolategȂ̂CɓȂc
static void (*gdcsubope[])(void) = {
			gdc_REPLACE, gdc_COMPLEMENT, gdc_CLEAR, gdc_SET};

LABEL static void __fastcall gdcsub_pset(WORD x, WORD y) {

		__asm {
				dec		nevent.remainclock
				cmp		dx, 409
				ja		outofscreen
				jne		screenxcheck
				cmp		cx, 384
				jae		outofscreen
		screenxcheck:
				cmp		cx, 640
				jae		outofscreen
				push	ebx
				push	ecx
				imul	ax, dx, 80
				xor		edx, edx
				mov		dx, cx
				shr		dx, 3
				add		dx, ax
				lea		ebx, vramupdate[edx]
				add		edx, gdcsubp
				not		cx
				and		cx, 7
				movzx	eax, operate
				and		eax, 3
				jmp		gdcsubope[eax*4]
		outofscreen:
				rol		pattern, 1
				ret
		}
}

#else								// l^
static void gdcsub_pset(WORD x, WORD y) {

	DWORD	pos;
	BYTE	bit;

	pos = (y * 80) + (x >> 3);
	if (pos >= 0x8000) {
		return;
	}
	bit = 0x80 >> (x & 7);
	switch(operate & 3) {
		case GDCOPE_REPLACE:
			if (pattern & 0x8000) {
				gdcsubp[pos] |= bit;
			}
			else {
				gdcsubp[pos] &= ~bit;
			}
			vramupdate[pos] |= updatebit;
			break;
		case GDCOPE_COMPLEMENT:
			if (pattern & 0x8000) {
				gdcsubp[pos] ^= bit;
				vramupdate[pos] |= updatebit;
			}
			break;
		case GDCOPE_CLEAR:
			if (pattern & 0x8000) {
				gdcsubp[pos] &= ~bit;
				vramupdate[pos] |= updatebit;
			}
			break;
		case GDCOPE_SET:
			if (pattern & 0x8000) {
				gdcsubp[pos] |= bit;
				vramupdate[pos] |= updatebit;
			}
			break;
	}
	pattern = (pattern << 1) | (pattern >> 15);
}
#endif

void gdcsub_line(DWORD csrw, VECT_TABLE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i;
	WORD	step;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	if (!vect->DC) {
		gdcsub_pset(x, y);
	}
	else {
		switch((vect->ope) & 7) {
			case 0:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x+step, y++);
				}
				break;

			case 1:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x++, y+step);
				}
				break;

			case 2:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x++, y-step);
				}
				break;

			case 3:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x+step, y--);
				}
				break;

			case 4:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x-step, y--);
				}
				break;

			case 5:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x--, y-step);
				}
				break;

			case 6:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x--, y+step);
				}
				break;

			case 7:
				for (i=0; i<=vect->DC; i++) {
					step = (WORD)((((vect->D1 * i) / vect->DC) + 1) >> 1);
					gdcsub_pset(x-step, y++);
				}
				break;
		}
	}
}

void gdcsub_box(DWORD csrw, VECT_TABLE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	// ]͂Ȃ(蔲)
	switch((vect->ope) & 7) {
		case 0:
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x--, y);
			}
			break;

		case 2:
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x, y++);
			}
			break;

		case 4:
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x++, y);
			}
			break;

		case 6:
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<(vect->D & 0x3fff); i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<(vect->D2 & 0x3fff); i++) {
				gdcsub_pset(x, y--);
			}
			break;
	}
}


void gdcsub_circle(DWORD csrw, VECT_TABLE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i, t;
	WORD	r, m, c;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	i = (vect->DM & 0x3fff);
	t = (vect->DC & 0x3fff);
	r = (vect->D & 0x3fff);
	m = (WORD)(((DWORD)r * 10000 + 14141) / 14142);
	if (t > m) {
		t = m;
	}
	switch((vect->ope) & 7) {
		case 0:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset((WORD)(x + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y + i);
			}
			break;

		case 1:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset(x + i, (WORD)(y + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
			}
			break;

		case 2:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset(x + i, (WORD)(y - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
			}
			break;

		case 3:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset((WORD)(x + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y - i);
			}
			break;

		case 4:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset((WORD)(x - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y - i);
			}
			break;

		case 5:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset(x - i, (WORD)(y - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
			}
			break;

		case 6:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset(x - i, (WORD)(y + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
			}
			break;

		case 7:
			for (; i<=t; i++) {
				c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
				gdcsub_pset((WORD)(x - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y + i);
			}
			break;
	}
}
