// 
// PD8253C ^C}LSI
// 

#include	<windows.h>
#include	"common.h"
#include	"i286.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"itimer.h"
#include	"nevent.h"
#include	"pic.h"
#include	"beep.h"

	ITIMER_TABLE	itimer;

void systimer(NEVENT_ITEM *item);

static void setsystimerevent(BOOL absolute) {

	DWORD	cnt;

	if (itimer.value[0].w) {
		cnt = pc.multiple * itimer.value[0].w;
	}
	else {
		cnt = pc.multiple << 16;
	}
	nevent_set(NEVENT_ITIMER, cnt, systimer, absolute);
}


void systimer(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		if ((itimer.mode[0] & 0x0c) == 0x04) {
			// [gWFl[^
			setsystimerevent(NEVENT_RELATIVE);
		}
	}
	pic_setirq(0);
}


static void itimer_latch(BYTE ch) {

	long	clock;

	switch(ch) {
		case 0:
			clock = nevent_getremain(NEVENT_ITIMER);
			if (clock >= 0) {
				itimer.latch[0].w = (WORD)(clock/pc.multiple);
			}
			else {
				itimer.latch[0].w = 0;
			}
			break;

		case 1:
			itimer.latch[1].w = itimer.value[1].w;
			break;

		case 2:
			clock = nevent_getremain(NEVENT_RS232C);
			if (clock >= 0) {
				itimer.latch[2].w = (WORD)(clock / pc.multiple);
			}
			else {
				itimer.latch[2].w = 0;
			}
			break;
	}
}


void itimer_init(void) {

	ZeroMemory(&itimer, sizeof(itimer));
	if (pc.cpumode & CPUMODE_8MHz) {
		itimer.value[1].w = 998;			// 4MHz
	}
	else {
		itimer.value[1].w = 1229;			// 5MHz
	}
	set_beephz(itimer.value[1].w);
}


I286_OUT itimer_w(WORD port, BYTE value) {

	int		ch;

	ch = (port >> 1) & 3;
	if (ch != 3) {
		switch(itimer.mode[ch] & 0x30) {
			case 0x10:		// access low
				itimer.value[ch].w = (WORD)value;
				break;

			case 0x20:		// access high
				itimer.value[ch].w = (WORD)value << 8;
				break;

			case 0x30:		// access word
				itimer.flag[ch] ^= 2;
				if (itimer.flag[ch] & 2) {
					itimer.value[ch].b[1] = value;
				}
				else {
					itimer.value[ch].b[0] = value;
					return;
				}
				break;
		}
	}

	switch(ch) {
		case 0:						// system timer
			setsystimerevent(NEVENT_ABSOLUTE);
			break;

		case 1:
			set_beephz(itimer.value[1].w);
			break;

		case 3:						// commands
			ch = (value >> 6) & 3;
			if (ch != 3) {
				ch = (value >> 6) & 3;
				itimer.mode[ch] = value;
				itimer.flag[ch] = 3;
				if (!(value & 0x30)) {				// latch
					itimer_latch(ch);
				}
			}
			break;
	}
}

I286_INB itimer_r(WORD port) {

	int		ch;
	long	clock;
	union {
		BYTE	b[2];
		WORD	w;
	} ret;

	ch = (port >> 1) & 3;
	if (ch != 3) {
		if (!(itimer.mode[ch] & 0x30)) {
			ret.w = itimer.latch[ch].w;
		}
		else {
			switch(ch) {
				case 0:
					clock = nevent_getremain(NEVENT_ITIMER);
					if (clock >= 0) {
						ret.w = (WORD)(clock / pc.multiple);
					}
					else {
						ret.w = 0;
					}
					break;

				case 1:
					ret.w = itimer.value[ch].w;
					break;

				case 2:
					clock = nevent_getremain(NEVENT_RS232C);
					if (clock >= 0) {
						ret.w = (WORD)(clock / pc.multiple);
					}
					else {
						ret.w = 0;
					}
					break;
			}
		}
		switch(itimer.mode[ch] & 0x30) {
			case 0x10:						// access low
				return(ret.b[0]);

			case 0x20:						// access high
				return(ret.b[1]);

			default:						// access word
				itimer.flag[ch] ^= 1;
				return(ret.b[itimer.flag[ch] & 1]);
		}
	}
	return(0xff);
}
