#include	<windows.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<stdarg.h>
#include	<math.h>
#include	"common.h"
#include	"np2.h"
#include	"iobridge.h"
#include	"dsound3.h"
#include	"opna.h"
#include	"pic.h"
#include	"pcm86.h"
#include	"nevent.h"
#include	"memory.h"
#include	"pc_core.h"
#include	"joystick.h"
#include	"rhythm.h"
#include	"keyboard.h"
#include	"s98.h"

void set_opmdrv_regster(BYTE reg, BYTE value, BYTE ch);
void PSGctrl(BYTE reg);

		OPNA_TABLE	opna;
		OPM_CH		OPMCH[MAXCHANNEL];

		WORD	beep_sounds = 0;

extern	long	detunetable[8][32];
extern	long	attacktable[94];
extern	long	decaytable[94];
extern	WORD	env_curve[];
extern	WORD	detune2table[];
extern	long	decayleveltable[];
extern	BYTE	multipletable[];
extern	long	nulltable[];

		long	outdl;
		long	outdc;
		long	outdr;
		long	feedback2;
		long	feedback3;
		long	feedback4;

		PSG_CH	PSGCH[3];
//		PSG_T	psg;

		BYTE	psgenv_mod = 0;
		BYTE	psgenv_vol = 0;
		BYTE	psgenv_volcnt = 0;
		WORD	psgenv_cnt = 0;
		WORD	psgenv_max = 0;

		DWORD	psgbase = (25000L << (16-2)) / (22050 / 5);

		WORD	psgnoise_cnt;
		WORD	psgnoise_freq;
		WORD	psgnoise_table[16];

extern	WORD	psg_puchidec;

extern	double	opmbaserate;

static	BYTE	psgenv_pat[16] = {
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONECYCLE,
					PSGENV_ONESHOT,
					0,
					PSGENV_ONESHOT | PSGENV_LASTON,
					PSGENV_ONECYCLE | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC | PSGENV_LASTON,
					PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC};




static void keyon_off(OPM_CH *CH, BYTE value) {

	int			i;
	BYTE		b;
	OPM_SLOT	*SLOT = &CH->SLOT[0];

	for (i=0,b=0x10; i<4; i++,b<<=1,SLOT++) {
		if (value & b) {							// keyon
			if (SLOT->env_mode <= EM_RELEASE) {
				SLOT->freq_cnt = 0;
				if (i == SLOT1) {
					CH->op1fb = 0;
				}
				SLOT->env_mode = EM_ATTACK;
				SLOT->env_inc = SLOT->env_inc_attack;
				SLOT->env_cnt = EC_ATTACK;
				SLOT->env_end = EC_DECAY;
			}
		}
		else {										// keyoff
			if (SLOT->env_mode > EM_RELEASE) {
				SLOT->env_mode = EM_RELEASE;
				if (!(SLOT->env_cnt & EC_DECAY)) {
					SLOT->env_cnt = ((long)env_curve[SLOT->env_cnt >> \
											ENV_BITS] << ENV_BITS) + EC_DECAY;
				}
				SLOT->env_end = EC_OFF;
				SLOT->env_inc = SLOT->env_inc_release;
			}
		}
	}
}


static void set_algorhythm(OPM_CH *CH) {

	long	*outd;

	switch(CH->pan & 0xc0) {
		case 0x80:
			outd = &outdl;
			break;
		case 0x40:
			outd = &outdr;
			break;
		default:
			outd = &outdc;
			break;
	}

	switch(CH->algorhythm) {
		case 0:
			CH->connect1 = &feedback2;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 1:
			CH->connect1 = &feedback3;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 2:
			CH->connect1 = &feedback4;
			CH->connect2 = &feedback3;
			CH->connect3 = &feedback4;
			break;
		case 3:
			CH->connect1 = &feedback2;
			CH->connect2 = &feedback4;
			CH->connect3 = &feedback4;
			break;
		case 4:
			CH->connect1 = &feedback2;
			CH->connect2 = outd;
			CH->connect3 = &feedback4;
			break;
		case 5:
			CH->connect1 = 0;
			CH->connect2 = outd;
			CH->connect3 = outd;
			break;
		case 6:
			CH->connect1 = &feedback2;
			CH->connect2 = outd;
			CH->connect3 = outd;
			break;
		default:
			CH->connect1 = outd;
			CH->connect2 = outd;
			CH->connect3 = outd;
	}
	CH->connect4 = outd;
}


static void set_dt1_mul(OPM_SLOT *SLOT, BYTE value) {

	SLOT->multiple = multipletable[value&0x0f];
	SLOT->detune1 = detunetable[(value>>4)&7];
}


static void set_tl(OPM_SLOT *SLOT, BYTE value) {

extern WORD fmvols[];

	SLOT->totallevel = ((~value) & 0x007f) << (EVC_BITS - 7);
}


static void set_ks_ar(OPM_SLOT *SLOT, BYTE value) {

	SLOT->keyscale = (BYTE)(((~value)>>6)&3);
	SLOT->attack = (value&=0x1f) ? &attacktable[value<<1] : nulltable;
	SLOT->env_inc_attack = SLOT->attack[SLOT->envraito];
	if (SLOT->env_mode == EM_ATTACK) {
		SLOT->env_inc = SLOT->env_inc_attack;
	}
}


static void set_d1r(OPM_SLOT *SLOT, BYTE value) {

	SLOT->decay1 = (value&=0x1f) ? &decaytable[value<<1] : nulltable;
	SLOT->env_inc_decay1 = SLOT->decay1[SLOT->envraito];
	if (SLOT->env_mode == EM_DECAY1) {
		SLOT->env_inc = SLOT->env_inc_decay1;
	}
}


static void set_dt2_d2r(OPM_SLOT *SLOT, BYTE value) {

//	SLOT->detune2 = detune2table[value>>6];			// OPNɂ͖^^;
	SLOT->decay2 = (value&=0x1f) ? &decaytable[value<<1] : nulltable;
	SLOT->env_inc_decay2 = SLOT->decay2[SLOT->envraito];
	if (SLOT->env_mode == EM_DECAY2) {
		SLOT->env_inc = SLOT->env_inc_decay2;
	}
}


static void set_d1l_rr(OPM_SLOT *SLOT, BYTE value) {

	SLOT->decaylevel = decayleveltable[(value>>4)];
	SLOT->release = &decaytable[((value&0x0f)<<2)|2];
	SLOT->env_inc_release = SLOT->release[SLOT->envraito];
	if (SLOT->env_mode == EM_RELEASE) {
		SLOT->env_inc = SLOT->env_inc_release;
#if 1
		if (value == 0xff) {
			SLOT->env_mode = EM_OFF;
			SLOT->env_cnt = EC_OFF;
			SLOT->env_end = EC_OFF+1;
			SLOT->env_inc = 0;
		}
#endif
	}
}


static void OPMchannleupdate(OPM_CH *CH) {

	int			i;
	WORD		fc = CH->keynote;
	BYTE		kc = CH->kcode;
	BYTE		evr;
	OPM_SLOT	*SLOT;

	SLOT = &CH->SLOT[0];
	for (i=0; i<4; i++, SLOT++) {
		SLOT->freq_inc = (fc + SLOT->detune1[kc]) * SLOT->multiple;
		evr = (BYTE)(kc >> SLOT->keyscale);
		if (SLOT->envraito != evr) {
			SLOT->envraito = evr;
			SLOT->env_inc_attack = SLOT->attack[evr];
			SLOT->env_inc_decay1 = SLOT->decay1[evr];
			SLOT->env_inc_decay2 = SLOT->decay2[evr];
			SLOT->env_inc_release = SLOT->release[evr];
		}
	}
}


//-----------------------------------------------------------------------------

void OPNAreset(void) {

	int		i, j;

	ZeroMemory(&opna, sizeof(opna));
	opna.channels = 3;
	opna.reg.b[0xff] = 0x01;
	opna.reg.psg.mixer = 0xbf;
	opna.reg.psg.io1 = 0xff;
	opna.reg.psg.io2 = 0xff;

	for(i=0; i<MAXCHANNEL; i++) {
		OPMCH[i].keynote = 0;
		for(j=0; j<4; j++) {
			OPMCH[i].SLOT[j].env_mode = EM_OFF;
			OPMCH[i].SLOT[j].env_cnt = EC_OFF;
			OPMCH[i].SLOT[j].env_end = EC_OFF+1;
			OPMCH[i].SLOT[j].env_inc = 0;

			OPMCH[i].SLOT[j].detune1 = detunetable[0];
			OPMCH[i].SLOT[j].attack = nulltable;
			OPMCH[i].SLOT[j].decay1 = nulltable;
			OPMCH[i].SLOT[j].decay2 = nulltable;
			OPMCH[i].SLOT[j].release = &decaytable[0];
		}
	}
	for (i=0x30; i<0xc0; i++) {
		opna.reg.b[i] = 0xff;
		opna.reg.b[i+0x100] = 0xff;
		set_opmdrv_regster(i, 0xff, 0);
		set_opmdrv_regster(i, 0xff, 3);
	}
	for (i=0; i<14; i++) {
		PSGctrl((BYTE)i);
	}
}



void OPNAinit(void) {

	OPNAInitTable();
	OPNAreset();
}


static void PSGctrl(BYTE reg) {

	switch(reg) {
		case 0: case 1:
			if ((opna.reg.psg.tune1 & 0xfff) >= 10) {
				PSGCH[0].psg_freq = (WORD)(psgbase /
											(opna.reg.psg.tune1 & 0xfff));
			}
			else {
				PSGCH[0].psg_freq = 0;
			}
			break;
		case 2: case 3:
			if ((opna.reg.psg.tune2 & 0xfff) >= 10) {
				PSGCH[1].psg_freq = (WORD)(psgbase /
											(opna.reg.psg.tune2 & 0xfff));
			}
			else {
				PSGCH[1].psg_freq = 0;
			}
			break;
		case 4: case 5:
			if ((opna.reg.psg.tune3 & 0xfff) >= 10) {
				PSGCH[2].psg_freq = (WORD)(psgbase /
											(opna.reg.psg.tune3 & 0xfff));
			}
			else {
				PSGCH[2].psg_freq = 0;
			}
			break;
		case 6:
			{
				int		i;
				int		value;
				int		freq;

				if ((value = opna.reg.psg.noise & 0x1f) == 0) {
					value = 1;
				}
				else {
					value <<= 1;
				}
				for (i=0; i<16; i++) {
					value++;
					if ((freq = (psgbase >> 1) / value) > 0xffffL) {
						freq = 0xffffL;
					}
					psgnoise_table[i] = (WORD)freq;
				}
				psgnoise_freq = psgnoise_table[0];
			}
			break;
		case 8:
			if (opna.reg.psg.vol1 & 0x10) {
				PSGCH[0].psg_volp = &psgenv_vol;
			}
			else {
				opna.reg.psg.vol1 &= (byte)0xf;
				PSGCH[0].psg_volp = &opna.reg.psg.vol1;
			}
			PSGCH[0].psg_puchinoise = psg_puchidec;
			break;
		case 9:
			if (opna.reg.psg.vol2 & 0x10) {
				PSGCH[1].psg_volp = &psgenv_vol;
			}
			else {
				opna.reg.psg.vol2 &= (byte)0xf;
				PSGCH[1].psg_volp = &opna.reg.psg.vol2;
			}
			PSGCH[1].psg_puchinoise = psg_puchidec;
			break;
		case 10:
			if (opna.reg.psg.vol3 & 0x10) {
				PSGCH[2].psg_volp = &psgenv_vol;
			}
			else {
				opna.reg.psg.vol3 &= (byte)0xf;
				PSGCH[2].psg_volp = &opna.reg.psg.vol3;
			}
			PSGCH[2].psg_puchinoise = psg_puchidec;
			break;
		case 11: case 12:
			if ((psgenv_max = (WORD)(opna_rate * opna.reg.psg.envtime
														/ 125000L)) == 0) {
				psgenv_max = 1;
			}
			break;
		case 13:
			psgenv_mod = psgenv_pat[opna.reg.psg.env & 0x0f];
			psgenv_volcnt = 16;
			psgenv_cnt = 1;
			break;
	}
}


static	char	OPN_FKTABLE[16] = {0,0,0,0,0,0,0,1,2,3,3,3,3,3,3,3};

void set_fmtimeraevent(BOOL absolute);
void set_fmtimerbevent(BOOL absolute);


void fmport_a(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		if (opna.reg.b[0x27] & 0x01) {
			opna.status |= 0x01;
		}
		if (opna.reg.b[0x27] & 0x04) {
			pcm86.write = 1;
			set_fmtimeraevent(NEVENT_RELATIVE);
			pic_setirq(0x0c);
		}
	}
}

void fmport_b(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		if (opna.reg.b[0x27] & 0x02) {
			opna.status |= 0x02;
		}
		if (opna.reg.b[0x27] & 0x08) {
			pcm86.write = 1;
			set_fmtimerbevent(NEVENT_RELATIVE);
			pic_setirq(0x0c);
		}
	}
}

void set_fmtimeraevent(BOOL absolute) {

	long l = 18 * (1024 - opna.timera);

	if (pc.cpumode & CPUMODE_8MHz) {		// 4MHz
		l = (l * 1248 / 625) * pc.multiple;
	}
	else {									// 5MHz
		l = (l * 1536 / 625) * pc.multiple;
	}
	nevent_set(NEVENT_FMTIMERA, l, fmport_a, absolute);
}

void set_fmtimerbevent(BOOL absolute) {

	long l = 288 * (256 - opna.timerb);

	if (pc.cpumode & CPUMODE_8MHz) {		// 4MHz
		l = (l * 1248 / 625) * pc.multiple;
	}
	else {									// 5MHz
		l = (l * 1536 / 625) * pc.multiple;
	}
	nevent_set(NEVENT_FMTIMERB, l, fmport_b, absolute);
}


static void set_opnasys_regster(BYTE reg, BYTE value) {

	long	l;

	switch(reg) {
		case 0x24:
			opna.timera = (value << 2) + (opna.timera & 3);
			break;

		case 0x25:
			opna.timera = (opna.timera & 0x3fc) + (value & 3);
			break;

		case 0x26:
			opna.timerb = value;
			break;

		case 0x27:
			opna.status &= ~((value & 0x30) >> 4);
			if ((value & 0x10) &&
				(!nevent_iswork(NEVENT_FMTIMERA))) {
				set_fmtimeraevent(NEVENT_ABSOLUTE);
			}
			if ((value & 0x20) &&
				(!nevent_iswork(NEVENT_FMTIMERB))) {
				set_fmtimerbevent(NEVENT_ABSOLUTE);
			}
			break;

		case 0x28:
			DSound_Send0();
			l = value & 0x0f;
			if (l < 3) {
				keyon_off(&OPMCH[l], value);
			}
			if ((opna.channels != 3) && (l >= 4) && (l < 7)) {
				keyon_off(&OPMCH[l-1], value);
			}
			break;
	}
}


static void set_opmdrv_regster(BYTE reg, BYTE value, BYTE ch) {

	BYTE		c;
	OPM_CH		*CH;
	OPM_SLOT	*SLOT;
	WORD		fn;
	BYTE		blk;

	if ((c = reg & 3) == 3) {
		return;
	}
	c += ch;
	CH = &OPMCH[c];
	SLOT = &CH->SLOT[(reg >> 2) & 3];
	if (reg < 0xa0) {
		switch(reg & 0xf0) {
			case 0x30:					// DT1 MUL
				set_dt1_mul(SLOT, value);
				OPMchannleupdate(CH);
				break;
			case 0x40:					// TL
				set_tl(SLOT, value);
				break;
			case 0x50:					// KS AR
				set_ks_ar(SLOT, value);
				OPMchannleupdate(CH);
				break;
			case 0x60:					// D1R
				set_d1r(SLOT, value);
				break;
			case 0x70:					// DT2 D2R
				set_dt2_d2r(SLOT, value);
				OPMchannleupdate(CH);
				break;
			case 0x80:					// D1L RR
				set_d1l_rr(SLOT, value);
				break;
		}
	}
	else {
		switch(reg & 0xfc) {
			case 0xa0:
				blk = CH->keyfunc >> 3;
				fn = (WORD)(((CH->keyfunc & 7) << 8) + value);
				CH->kcode = (blk << 2) | OPN_FKTABLE[fn >> 7];
				CH->keynote = (WORD)((double)fn * 55556 * opmbaserate
													/ (1L << (23-blk-1)));
				OPMchannleupdate(CH);
				break;
			case 0xa4:
				CH->keyfunc = value & 0x3f;
				break;
			case 0xb0:
				CH->algorhythm = (BYTE)(value&7);
				CH->feedback = (BYTE)((8-((value>>3)&7))&7);
									// case 0: ret(0) / other ret(8-fb)
				set_algorhythm(CH);
				break;
			case 0xb4:
				CH->pan = (BYTE)(value & 0xc0);
				set_algorhythm(CH);
				break;
		}
	}
}


static void rhythm_w(BYTE reg, BYTE value) {

	BYTE	bit;
	int		i;

	if (reg == 0x10) {
		DSound_Send0();
#if 1
		for (i=0, bit=1; i<6; i++, bit<<=1) {
			if (value & bit) {
				rhythm_play(i, value & 0x80);
			}
		}
#else
		for (i=0, bit=1; i<6; i++, bit<<=1) {
			if ((!(opna.reg.b[0x10] & bit)) && (value & bit)) {
				rhythm_play(i, value & 0x80);
			}
		}
#endif
	}
}


I286_OUT opna_w(WORD port, BYTE value) {

	switch(port & 7) {
		case 0:
			opna.opnreg = value;
			break;
		case 2:
			S98_put(0, opna.opnreg, value);
			if (opna.opnreg < 0x10) {
				if (opna.opnreg != 0x0e) {
					opna.reg.b[opna.opnreg] = value;
					DSound_Send0();
					PSGctrl(opna.opnreg);
				}
			}
			else {
				if (opna.opnreg < 0x20) {
					rhythm_w(opna.opnreg, value);
				}
				else if (opna.opnreg < 0x30) {
					set_opnasys_regster(opna.opnreg, value);
				}
				else if (opna.opnreg < 0xc0) {
					DSound_Send0();
					set_opmdrv_regster(opna.opnreg, value, 0);
				}
				opna.reg.b[opna.opnreg] = value;
			}
			break;
		case 4:
			opna.extreg = value;
			break;
		case 6:
			S98_put(1, opna.extreg, value);
			opna.reg.b[opna.extreg + 0x100] = value;
			if (opna.extreg >= 0x30) {
				DSound_Send0();
				set_opmdrv_regster(opna.extreg, value, 3);
			}
			break;
	}
}

I286_INB opna_r(WORD port) {

static BYTE rapids = 0;

	switch(port & 7) {
		case 0:
			return(opna.status);

		case 2:
			if (opna.opnreg == 0x0e) {
				BYTE ret = 0xff;
				if (!(opna.reg.b[0x0f] & 0x40)) {
					ret &= joy_getflag();
					if (np2cfg.KEY_MODE == 1) {
						ret &= joykey();
					}
				}
				else {
					if (np2cfg.KEY_MODE == 2) {
						ret &= joykey();
					}
				}
				if (np2cfg.BTN_RAPID) {
					rapids ^= 0x60;
					ret |= rapids;
				}
				if (np2cfg.BTN_MODE) {
					BYTE bit1 = (ret & 0x40) >> 1;
					BYTE bit2 = (ret & 0x20) << 1;
					ret = (ret & (~0x60)) | bit1 | bit2;
				}
				return(ret);
			}
			return(opna.reg.b[opna.opnreg]);

		case 4:
			if (opna.channels != 3) {
				return(opna.status & 3);
			}
			break;

		case 6:
			if (opna.channels != 3) {
				return(opna.reg.b[opna.opnreg]);
			}
			break;
	}
	return(0xff);
}


void OPNAtrash(void) {}

